class GoreNest : Actor {
	Default	{
		Health 1000;
		Radius 32;
		Height 64;
		Mass 9999999;
		Speed 0;
		PainChance 0;
		Monster;
		+FLOORCLIP
		+NOTARGET
		+MISSILEMORE
		+MISSILEEVENMORE
		SeeSound "gorenest/see";
		PainSound "gorenest/pain";
		DeathSound "gorenest/death";
		Obituary "%o was culled by a Gore Nest.";
	}
}

class GoreNestRed : GoreNest {
	States	{
		Spawn:
			GNRE A 10 A_Look;
			Loop;
		See:
			GNRE AABB 3 A_Chase;
			Loop;
		Missile:
			GNRE CD 8 A_FaceTarget;
			TNT1 A 0 A_SpawnProjectile("DoomImpBall", 48, 0, 10);
			GNRE E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, -10);
			TNT1 A 0 A_SpawnProjectile("DoomImpBall", 48, 0, 0, CMF_OFFSETPITCH, 10);
			GNRE E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 0, CMF_OFFSETPITCH, -10);
			GNRE E 6 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, 0);
			Goto See;
		Death:
			GNRE H 7;
			GNRE I 7 A_Scream;
			GNRE J 7 A_NoBlocking;
			GNRE KLMNOPQR 7;
			GNRE S -1;
			Stop;
	}
}

class GoreNestBrown : GoreNest {
	States	{
		Spawn:
			GNBR A 10 A_Look;
			Loop;
		See:
			GNBR AABB 3 A_Chase;
			Loop;
		Missile:
			GNBR CD 8 A_FaceTarget;
			TNT1 A 0 A_SpawnProjectile("DoomImpBall", 48, 0, -8);
			GNBR E 4 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 8);
			TNT1 A 0 A_SpawnProjectile("DoomImpBall", 48, 0, -16);
			GNBR E 4 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 16);
			GNBR E 4 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, 0);
			Goto See;
		Death:
			GNBR H 7;
			GNBR I 7 A_Scream;
			GNBR J 7 A_NoBlocking;
			GNBR KLMNOPQR 7;
			GNBR S -1;
			Stop;
	}
}

class GoreNestGreen : GoreNest {
	States	{
		Spawn:
			GNGR A 10 A_Look;
			Loop;
		See:
			GNGR AABB 3 A_Chase;
			Loop;
		Missile:
			GNGR CD 8 A_FaceTarget;
			GNGR E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, random(-10,10));
			GNGR E 2 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, random(-10,10));
			GNGR E 2 BRIGHT A_SpawnProjectile("BaronBall", 48, 0, random(-10,10));
			GNGR E 2 BRIGHT A_SpawnProjectile("FatShot", 48, 0, random(-10,10));
			GNGR E 4 BRIGHT A_SpawnProjectile("ArachnotronPlasma", 48, 0, random(-10,10));
			Goto See;
		Death:
			GNGR H 7;
			GNGR I 7 A_Scream;
			GNGR J 7 A_NoBlocking;
			GNGR KLMNOPQR 7;
			GNGR S -1;
			Stop;
	}
}

class GoreNestBlue : GoreNest {
	States	{
		Spawn:
			GNBL A 10 A_Look;
			Loop;
		See:
			GNBL AABB 3 A_Chase;
			Loop;
		Missile:
			GNBL CD 8 A_FaceTarget;
			GNBL E 4 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 0);
			GNBL E 4 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, 0);
			GNBL E 4 BRIGHT A_SpawnProjectile("BaronBall", 48, 0, 0);
			GNBL E 4 BRIGHT A_SpawnProjectile("FatShot", 48, 0, 0);
			Goto See;
		Death:
			GNBL H 7;
			GNBL I 7 A_Scream;
			GNBL J 7 A_NoBlocking;
			GNBL KLMNOPQR 7;
			GNBL S -1;
			Stop;
	}
}

class GoreNestMagenta : GoreNest {
	States	{
		Spawn:
			GNPU A 10 A_Look;
			Loop;
		See:
			GNPU AABB 3 A_Chase;
			Loop;
		Missile:
			GNPU CD 8 A_FaceTarget;
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 10);
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 4, CMF_OFFSETPITCH, -8);
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, -4, CMF_OFFSETPITCH, -8);
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, -10);
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, -4, CMF_OFFSETPITCH, 8);
			GNPU E 2 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 4, CMF_OFFSETPITCH, 8);
			GNPU E 2 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, 0);
			Goto See;
		Death:
			GNPU H 7;
			GNPU I 7 A_Scream;
			GNPU J 7 A_NoBlocking;
			GNPU KLMNOPQR 7;
			GNPU S -1;
			Stop;
	}
}

// To be modified further, not used yet
class GoreNestGrey : GoreNest {
	States	{
		Spawn:
			GNGY A 10 A_Look;
			Loop;
		See:
			GNGY AABB 3 A_Chase;
			Loop;
		Missile:
			GNGY CD 8 A_FaceTarget;
			GNGY E 4 BRIGHT A_SpawnProjectile("DoomImpBall", 48, 0, 0);
			GNGY E 4 BRIGHT A_SpawnProjectile("CacodemonBall", 48, 0, 0);
			GNGY E 4 BRIGHT A_SpawnProjectile("BaronBall", 48, 0, 0);
			GNGY E 4 BRIGHT A_SpawnProjectile("FatShot", 48, 0, 0);
			Goto See;
		Death:
			GNGY H 7;
			GNGY I 7 A_Scream;
			GNGY J 7 A_NoBlocking;
			GNGY KLMNOPQR 7;
			GNGY S -1;
			Stop;
	}
}