class ShadowImp : DoomImp {
	Default	{
		//$Category Monsters
		//$Sprite TRO2A1
		Speed 10;
		Translation "64:79=80:111";
		HitObituary "%o was slashed by a Shadow Imp.";
		Obituary "%o was burned by a Shadow Imp.";
		Tag "Shadow Imp";
		+MISSILEMORE
	}
	States {
		Missile:
			TROO EF 6 A_FaceTarget;
			TROO G 4 A_CustomComboAttack("ShadowImpBall", 32, 3 * random(1, 8), "imp/melee");
			TROO G 4 A_CustomComboAttack("ShadowImpBall", 32, 3 * random(1, 8), "imp/melee");
			Goto See;
	}
}

class ShadowImpBall : DoomImpBall {
	Default	{
		Speed 20;
		Translation "168:191=24:47";
	}
}

class BloodDemon : Demon {
	Default	{
		//$Category Monsters
		//$Sprite SAR2A1
		Speed 8;
		Translation "16:47=170:191";
		Obituary "%o was bit by a Blood Demon.";
		Tag "Blood Demon";
	}
	States {
		See:
			SARG AABBCCDD 1 A_Chase;
			Loop;
		Melee:
			SARG EF 4 A_FaceTarget;
			SARG G 4 A_SargAttack;
			Goto See;
		Pain:
			SARG H 1;
			SARG H 1 A_Pain;
			Goto See;
	}
}

class BloodSpectre : BloodDemon {
	Default	{
		+SHADOW
		RenderStyle "Translucent";
		Alpha 0.4;
		Obituary "%o was eaten by a Blood Spectre.";
		Tag "Blood Spectre";
	}

}

class PlasmaGuy : Actor
{
	Default
	{
		//$Category Monsters
		//$Sprite ACP2A1
		Health 80;
		Radius 20;
		Height 56;
		Mass 100;
		Speed 8;
		PainChance 140;
		Monster;
		Translation "16:47=192:207";
		+FLOORCLIP
		+DOHARMSPECIES
		SeeSound "chainguy/sight";
		PainSound "chainguy/pain";
		DeathSound "chainguy/death";
		ActiveSound "chainguy/active";
		//AttackSound "chainguy/attack";
		Obituary "%o was melted by a Plasma Dude.";
		Tag "PlasmaGuy";
		DropItem "InfSmallCell", 255, 5;
	}
	States
	{
	Spawn:
		ACPS AB 10 A_Look;
		Loop;
	See:
		ACPS AABBCCDD 2 A_Chase;
		Loop;
	Missile:
		ACPS E 10 A_FaceTarget;
		ACPS F 2 BRIGHT A_SpawnProjectile("PlasmaGuyPlasma");
		ACPS E 2;
		ACPS F 2 BRIGHT A_SpawnProjectile("PlasmaGuyPlasma");
		ACPS E 2;
		Goto See;
	Pain:
		ACPS G 3;
		ACPS G 3 A_Pain;
		Goto See;
	Death:
		TNT1 A 0 A_Jump (125, "AltDeath");
		ACPS H 5;
		ACPS I 5 A_Scream;
		ACPS J 5 A_NoBlocking;
		ACPS KLM 5;
		ACPS N -1;
		Stop;
	AltDeath:
		ACPS V 5 A_Scream;
		ACPS W 5;
		ACPS X 5 A_NoBlocking;
		ACPS Y 5;
		ACPS Z -1;
		Stop;
	XDeath:
		ACPS O 5;
		ACPS P 5 A_XScream;
		ACPS Q 5 A_NoBlocking;
		ACPS RS 5;
		ACPS T -1;
		Stop;
	Raise:
		ACPS N 5;
		ACPS MLKJIH 5;
		Goto See;
	}
}

class PlasmaGuyPlasma : ArachnotronPlasma {
	Default	{
		Translation "112:127=208:223";
	}
}

class BabyCaco : Cacodemon {
	Default	{
		//$Category Monsters
		Health 80;
		Radius 18;
		Height 36;
		Mass 200;
		Translation "168:191=16:47";
		SeeSound "babycaco/sight";
		PainSound "babycaco/pain";
		DeathSound "babycaco/death";
		ActiveSound "babycaco/active";
		Obituary "%o was smitten by a Baby Cacodemon.";
		HitObituary "%o got too close to a Baby Cacodemon.";
		Tag "Baby Cacodemon";
	}
	States {
		Spawn:
			CACB A 10 A_Look;
			Loop;
		See:
			CACB A 2 A_Chase;
			Loop;
		Missile:
			CACB B 5 A_FaceTarget;
			CACB C 5 A_FaceTarget;
			CACB D 5 BRIGHT A_CustomComboAttack("CacodemonBall", 16, 5*random(1,6));
			Goto See;
		Pain:
			CACB E 3;
			CACB E 3 A_Pain;
			CACB F 6;
			Goto See;
		Death:
			CACB G 8;
			CACB H 8 A_Scream;
			CACB I 8;
			CACB J 8;
			CACB K 8 A_NoBlocking;
			CACB L -1 A_SetFloorClip;
			Stop;
		Raise:
			CACB L 8 A_UnSetFloorClip;
			CACB KJIHG 8;
			Goto See;
	}
}

class MamaCaco : Cacodemon {
	Default	{
		//$Category Monsters
		Health 600;
		Radius 45;
		Height 80;
		Mass 800;
		PainChance 80;
		Scale 1.5;
		Translation "168:191=32:47";
		+MISSILEMORE
		SeeSound "mamacaco/sight";
		PainSound "mamacaco/pain";
		DeathSound "mamacaco/death";
		ActiveSound "mamacaco/active";
		Obituary "%o was smitten by a Mama Cacodemon.";
		HitObituary "%o got too close to a Mama Cacodemon.";
		Tag "Mama Cacodemon";
	}
	States {
		Spawn:
			HEAD A 10 A_Look;
			Loop;
		See:
			HEAD A 3 A_Chase;
			Loop;
		Missile:
			HEAD B 5 A_FaceTarget;
			HEAD C 5 A_FaceTarget;
			TNT1 A 0 A_StartSound("mamacaco/attack", CHAN_AUTO);
			HEAD DD 2 BRIGHT A_CustomComboAttack("MamaCacodemonBall", 42, 5*random(1,6));
			Goto See;
		Pain:
			HEAD E 3;
			HEAD E 3 A_Pain;
			HEAD F 6;
			Goto See;
		Death:
			HEAD G 8;
			HEAD H 8 A_Scream;
			HEAD I 8;
			HEAD J 8 A_PainDie("BabyCaco");
			HEAD K 6 A_NoBlocking;
			HEAD L 6;
			HEAD M -1 A_SetFloorClip;
			Stop;
		Raise:
			Stop;
	}
}

class MamaCacodemonBall : CacodemonBall {
	Default	{
 		Radius 16;
		Height 24;
		Speed 25;
 		FastSpeed 25;
		Damage 5;
		Scale 3;
		SeeSound "";
		+ROCKETTRAIL
	}
}

class LesserCyberdemon : Cyberdemon {
	Default	{
		//$Category Monsters
		Health 2000;
		Radius 35;
		Height 96;
		Mass 750;
		Speed 14;
		PainChance 25;
		-BOSS 
		-BOSSDEATH
		Scale 0.875;
		SeeSound "babycyber/sight";
		DeathSound "babycyber/death";
		Obituary "%o was splattered by a Lesser Cyberdemon.";
		Tag "Lesser Cyberdemon";
	}
	States {
		Spawn:
			CYBG AB 10 A_Look;
			Loop;
		See:
			CYBG A 3 A_Hoof;
			CYBG ABBCC 3 A_Chase;
			CYBG D 3 A_Metal;
			CYBG D 3 A_Chase;
			Loop;
		Missile:
			CYBG E 6 A_FaceTarget;
			CYBG F 12 A_CyberAttack;
			CYBG E 12 A_FaceTarget;
			CYBG F 12 A_CyberAttack;
			Goto See;
		Pain:
			CYBG G 10 A_Pain;
			Goto See;
		Death:
			CYBG H 10;
			CYBG I 10 A_Scream;
			CYBG JKL 10;
			CYBG M 10 A_NoBlocking;
			CYBG NO 10;
			CYBG P 30;
			CYBG P -1;
			Stop;
	}
}

class Annihilator : Cyberdemon {
	Default	{
		//$Category Monsters
		Health 5000;
		Speed 14;
		Obituary "%o was splattered by an Annihilator.";
		Tag "Annihilator";
		+MISSILEEVENMORE
	}
	States {
		Spawn:
			ANNI AB 10 A_Look;
			Loop;
		See:
			ANNI A 2 A_Hoof;
			ANNI ABBCC 2 A_Chase;
			ANNI D 2 A_Metal;
			ANNI D 2 A_Chase;
			Loop;
		Missile:
			TNT1 A 0 A_Jump(128, "SeekerMissiles");
			ANNI E 6 A_FaceTarget;
			TNT1 A 0 A_SpawnProjectile("Rocket", 48, -27, 0, CMF_AIMOFFSET);
			ANNI F 12 A_SpawnProjectile("Rocket", 48, 27, 0, CMF_AIMOFFSET);
			ANNI E 12 A_FaceTarget;
			TNT1 A 0 A_SpawnProjectile("Rocket", 48, -27, 0, CMF_AIMOFFSET);
			ANNI F 12 A_SpawnProjectile("Rocket", 48, 27, 0, CMF_AIMOFFSET);
			ANNI E 12 A_FaceTarget;
			TNT1 A 0 A_SpawnProjectile("Rocket", 48, -27, 0, CMF_AIMOFFSET);
			ANNI F 12 A_SpawnProjectile("Rocket", 48, 27, 0, CMF_AIMOFFSET);
			Goto See;
		SeekerMissiles:
			ANNI E 6 A_FaceTarget;
			ANNI F 6 A_SpawnProjectile("CyberSeekerRocket", 48, -27, 0, CMF_OFFSETPITCH, -90);
			ANNI E 6 A_FaceTarget;
			ANNI F 6 A_SpawnProjectile("CyberSeekerRocket", 48, 27, 0, CMF_OFFSETPITCH, -90);
			ANNI E 6 A_FaceTarget;
			ANNI F 6 A_SpawnProjectile("CyberSeekerRocket", 48, -27, 0, CMF_OFFSETPITCH, -90);
			ANNI E 6 A_FaceTarget;
			ANNI F 6 A_SpawnProjectile("CyberSeekerRocket", 48, 27, 0, CMF_OFFSETPITCH, -90);
			Goto See;
		Pain:
			ANNI G 8 A_Pain;
			Goto See;
		Death:
			ANNI H 10;
			ANNI I 10 A_Scream;
			ANNI JKL 10;
			ANNI M 10 A_NoBlocking;
			ANNI NO 10;
			ANNI P 30;
			ANNI P -1;
			Stop;
	}
}

class CyberSeekerRocket : Rocket {
	Default	{
		Speed 20;
		+SEEKERMISSILE
		-NOGRAVITY
		Gravity 1;
	}
	States {
	Spawn:
		MISL A 20;
		TNT1 A 0 A_SeekerMissile(0, 180, SMF_PRECISE);
		Goto Seek;
	Seek:
		MISL A 1 A_SeekerMissile(0, 1);
		TNT1 A 0 A_JumpIfCloser(64, "StopSeeking");
		Loop;
	StopSeeking:
		MISL A 5;
		Loop;
	Death:
		MISL B 8 Bright A_Explode;
		MISL C 6 Bright;
		MISL D 4 Bright;
		Stop;
	}	
}

class ArachnotronNoRaise : Arachnotron {
	States {
		Raise:
			Stop;
	}
}

class FatsoNoRaise : Fatso {
	States {
		Raise:
			Stop;
	}
}

class RevenantNoRaise : Revenant {
	States {
		Raise:
			Stop;
	}
}

class CacoFlatCorpse : Cacodemon {
	States {
		Death:
			HEAD G 8;
			HEAD H 8 A_Scream;
			HEAD IJ 8;
			HEAD K 6 A_NoBlocking;
			HEAD L 6;
			HEAD M -1 A_SetFloorClip;
			Stop;
	}
}